avheight = 5
Variation = 15
delay = 200

start:
'Bomber! By Robert Fisher 1993

CLS : SCREEN 13
PRINT : PRINT : PRINT : PRINT "Welcome to Bomber"
cc(1) = 4
cc(2) = 6
cc(3) = 8
cc(4) = 12
cc(5) = 20

PRINT "By Robert Fisher"
PRINT "Version 1.00"
PRINT "August 1993"
PRINT ""
PRINT ""
PRINT "Press P to Play"
PRINT "Press O for Options"
choose:
l$ = INKEY$
IF UCASE$(l$) = "P" THEN GOTO go
IF UCASE$(l$) = "O" THEN GOTO options
GOTO choose

go:
'Randomize Buildings
bomb = 0
DIM buildings(40)
amount = 40

FOR b = 4 TO amount - 3
buildings(b) = INT(RND * (avheight - Variation) + Variation)
NEXT b

'Draw buildings
CLS
COLOR 60
FOR b = 1 TO amount
FOR h = 1 TO buildings(b)
LOCATE (24 - h), b: PRINT ""
NEXT h
COLOR b + 60
NEXT b

'make plane fly
score = 0
x = 1: y = 1
xx = 1
yy = 1
LOCATE 25, 1: PRINT "Score:      High Score:"; hiscore; "by "; hiname$;
fly:
LOCATE 25, 7: PRINT score;
IF INKEY$ = " " THEN GOSUB bomb                 'Check for spacebar press
LOCATE y, x: PRINT ""                          'Print Aeroplane
IF buildings(x) > (23 - y) THEN GOTO crash      'Detect Crash
xx = xx + 1                                     'Calculate new position
IF xx > 40 THEN xx = 1: yy = yy + 1
FOR t = 1 TO delay: NEXT t                        'Time Delay
LOCATE y, x: PRINT " "                          'Blank old position
x = xx: y = yy                                  'Prepare for new position
IF bomb = 1 THEN GOSUB movebomb                 'Make the bomb fall
IF y = 23 AND x = 20 THEN GOTO win
GOTO fly

bomb:
IF bomb = 1 THEN GOTO endbomb                                   'Check for existing bomb
bomb = 1                                                        'Existing bomb = YES
bx = x: by = y + 1: IF by > 23 THEN bomb = 0: GOTO endbomb      'Set up new bomb position
LOCATE by, bx: PRINT "!"                                        'Print bomb
endbomb:
RETURN

movebomb:
IF hit = 1 THEN count = count - 1: score = score + 10: buildings(bx) = buildings(bx) - 1: PLAY "l64 n20"
LOCATE by, bx: PRINT " "                                         'Clear old position
by = by + 1                                                      'New position
IF by > 23 THEN bomb = 0: hit = 0: GOTO movend                'Bomb hits ground?
IF hit = 1 AND count < 1 THEN bomb = 0: hit = 0: GOTO movend     'Bomb runs out?
IF hit = 0 AND by > (23 - buildings(bx)) THEN hit = 1: count = cc(INT(RND * 4 + 1))
LOCATE by, bx: PRINT "!"
movend:
RETURN

crash:
COLOR 12
LOCATE y - 1, x: PRINT "*"
PLAY "l2 n20"
LOCATE y + 1, x: PRINT "*"
PLAY "n19"
LOCATE y, x - 1: PRINT "*"
PLAY "n18"
LOCATE y, x + 1: PRINT "*"
PLAY "n17"
LOCATE y, x: PRINT "*"
PLAY "n16"
LOCATE y - 4, x + 4: PRINT "YOU HAVE CRASHED!!"
keywait:
IF LEN(INKEY$) < 1 THEN GOTO keywait

CLS
PRINT "You have scored"; score; " points."
IF score > hiscore THEN hiscore = score: PRINT "A new High Score!": GOSUB hiname
kw:
IF LEN(INKEY$) < 1 THEN GOTO kw
GOTO start

hiname:
PRINT
INPUT "Please type your name: ", hiname$
RETURN

win:
PLAY "l8 cdefgab"
LOCATE 5, 5: PRINT "Well Done! You Made it!"
waitkey2:
IF LEN(INKEY$) < 1 THEN GOTO waitkey2

CLS
PRINT "You have scored"; score; " points."
PRINT "Plus a bonus of 500.": score = score + 500
IF score > hiscore THEN hiscore = score: PRINT "A new High Score!": GOSUB hiname
kw2:
IF LEN(INKEY$) < 1 THEN GOTO kw
GOTO start

options:
GOSUB buildopt

'make plane fly
x = 1: y = 1
xx = 1
yy = 1
fly2:
LOCATE 7, x: PRINT ""                          'Print Aeroplane
xx = xx + 1                                     'Calculate new position
IF xx > 40 THEN xx = 1
FOR t = 1 TO delay: NEXT t                        'Time Delay
LOCATE 7, x: PRINT " "                          'Blank old position
x = xx: y = yy                                  'Prepare for new position
i$ = INKEY$
IF i$ = "+" THEN delay = delay - 20: IF delay < 0 THEN delay = 0
IF i$ = "-" THEN delay = delay + 20
IF i$ = "7" THEN avheight = avheight + 2: GOSUB buildopt
IF i$ = "1" THEN avheight = avheight - 2: GOSUB buildopt
IF i$ = "8" THEN Variation = Variation + 2: GOSUB buildopt
IF i$ = "2" THEN Variation = Variation - 2: GOSUB buildopt
IF i$ = " " THEN GOTO go
GOTO fly2

buildopt:
'Randomize Buildings

amount = 40

FOR b = 4 TO amount - 3
buildings(b) = RND * (avheight - Variation) + Variation
NEXT b

'Draw buildings
CLS
PRINT "Options."
PRINT ""
PRINT "Adjust Speed +/-"
PRINT "Height 7/1   Variation 8/2"
PRINT ""
LOCATE 25, 1: PRINT "Height:"; avheight; "  Var:"; Variation
COLOR 60
FOR b = 1 TO amount
FOR h = 1 TO buildings(b)
LOCATE (24 - h), b: PRINT ""
NEXT h
COLOR b + 60
NEXT b
RETURN



